(set-logic QF_BV)

(define-fun myabs ((x (_ BitVec 32))) (_ BitVec 32) (ite (bvslt x (_ bv0 32)) (bvneg x) x))

(declare-const x (_ BitVec 32))
(declare-const y (_ BitVec 32))

(assert (= y (bvashr x (_ bv31 32))))

(push)
(assert (not(= (myabs x) (bvsub (bvxor x y) y))))
(check-sat)
(pop)

(push)
(assert (not(= (myabs x) (bvxor (bvadd x y) y))))
(check-sat)
(pop)

(push)
(assert (not(= (myabs x) (bvsub x (bvand (bvadd x x) y)))))
(check-sat)
(pop)

